var extLinkPropsSvc = {
	channel: null,
	fullHeader: null,
	realCount: 0,
	stringbundle: null,

	get isPropsDialog() {
		delete this.isPropsDialog;
		return this.isPropsDialog = "showMetadataFor" in window;
	},
	get isDownloadDialog() {
		delete this.isDownloadDialog;
		return this.isDownloadDialog = "HelperApps" in window;
	},
	get isOwnWindow() {
		delete this.isOwnWindow;
		return this.isOwnWindow = "extLinkPropsWnd" in window;
	},
	get wnd() { return extLinkPropsWnd; },
	get pu() { return extLinkPropsPrefUtils; },

	init: function() {
		window.removeEventListener("load", this, false);
		window.addEventListener("beforeunload", this, false);
		this.pu.prefsMigration();
		this.showHideStatus();
		this.showHideHeaders();
		this.stringbundle = Components.classes["@mozilla.org/intl/stringbundle;1"]
			.getService(Components.interfaces.nsIStringBundleService)
			.createBundle("chrome://extlinkprops/locale/extlinkprops.properties");
		this.fullHeader = document.getElementById("extLinkProps-headers");
		if(this.isPropsDialog) {
			document.getElementById("extLinkProps-separator").setAttribute(
				"hidden",
				document.getElementById("link-sec").nextSibling.style.display == "none"
			);
		}
		if(!this.isOwnWindow || this.wnd.autostart)
			this.getHeaders();
	},
	destroy: function() {
		window.removeEventListener("beforeunload", this, false);
		if(!this.channel)
			return;
		this.channel.cancel(0);
		this.channel = null;
	},
	handleEvent: function(e) {
		switch(e.type) {
			case "load":         this.init();    break;
			case "beforeunload": this.destroy();
		}
	},
	showHideStatus: function() {
		this.showHideRow("Status", "showResponseStatus");
	},
	showHideHeaders: function() {
		this.showHideRow("Headers", "showHttpHeaders");
	},
	showHideRow: function(rowId, pName) {
		var row = document.getElementById("extLinkProps-row" + rowId);
		if(
			this.isPropsDialog && this.pu.pref("properties." + pName)
			|| this.isDownloadDialog && this.pu.pref("download." + pName)
			|| this.isOwnWindow && this.pu.pref("ownWindow." + pName)
		)
			row.removeAttribute("hidden");
		else
			row.setAttribute("hidden", "true");
	},
	prefsChanged: function(pName) {
		if(pName.indexOf(".showHttpHeaders") != -1) {
			this.showHideHeaders();
			this.isOwnWindow && this.wnd.fixWindowHeight();
		}
		else if(pName.indexOf(".showResponseStatus") != -1) {
			this.showHideStatus();
			this.isOwnWindow && this.wnd.fixWindowHeight();
		}
		else if(pName == "sizePrecision") {
			this.convertSize();
		}
	},
	getHeaders: function(isManualCall) {
		if(isManualCall) {
			this.clearResults();
			if(this.isOwnWindow)
				this.wnd.referer = null;
		}
		if(this.request())
			document.getElementById("extLinkProps-container").removeAttribute("hidden");
	},
	clearResults: function() {
		Array.forEach(
			document.getElementById("extLinkProps-container").getElementsByTagName("textbox"),
			function(tb) {
				if(tb.readOnly) {
					this.setMissingStyle(tb, false);
					tb.value = "";
				}
			},
			this
		);
		this.realCount = 0;
		this._lastSize = this._lastSizeTip = null;
	},
	openOptions: function() {
		var win = Components.classes["@mozilla.org/appshell/window-mediator;1"]
			.getService(Components.interfaces.nsIWindowMediator)
			.getMostRecentWindow("extLinkProps:optionsWindow");
		if(win) {
			win.focus();
			return;
		}
		window.openDialog("chrome://extlinkprops/content/options.xul", "_blank", "chrome,centerscreen");
	},
	openOptionsClick: function(e) {
		var col = document.getElementById("extLinkProps-columnLabels");
		var bo = col.boxObject;
		if(
			   e.screenX >= bo.screenX && e.screenX <= bo.screenX + bo.width
			&& e.screenY >= bo.screenY && e.screenY <= bo.screenY + bo.height
		)
			this.openOptions();
	},

	request: function() {
		var _uri = this.uri;
		if(!_uri)
			return false;

		this._lastSize = this._lastSizeTip = null;
		this._hasSize = this._hasType = false;

		if(this.isDownloadDialog) {
			var dl = dialog.mLauncher;
			if("contentLength" in dl && dl.contentLength) // https://bugzilla.mozilla.org/show_bug.cgi?id=455913
				this.formatSize(dl.contentLength);
			if("MIMEInfo" in dl) {
				var mi = dl.MIMEInfo;
				if("MIMEType" in mi && mi.MIMEType)
					this.formatType(mi.MIMEType);
				else if("type" in mi && mi.type)
					this.formatType(mi.type);
			}
		}

		try {
			// Ugly workaround...
			// Request will be sended after downloading file from "_uri" to %temp%.
			// Following works for me in some tests, but it is very bad hack.
			if(this.isDownloadDialog)
				_uri += "?" + Math.random().toFixed(32).substr(2);

			var uri = Components.classes["@mozilla.org/network/standard-url;1"]
				.createInstance(Components.interfaces.nsIURI);
			uri.spec = _uri;
			var schm = uri.scheme && uri.scheme.toLowerCase();
			if(schm != "http" && schm != "https" && schm != "ftp" && schm != "ftps")
				return false;
			if(this.channel)
				this.channel.cancel(0);
			var ch = this.channel = Components.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService)
				.newChannelFromURI(uri);

			if(ch instanceof Components.interfaces.nsIFTPChannel) {
				//alert(opener.handyClicks.ut.objProps(this.channel));
				ch.loadFlags |= ch.LOAD_BACKGROUND | ch.INHIBIT_CACHING;
				ch.asyncOpen(this, null);
				return true;
			}

			ch.QueryInterface(Components.interfaces.nsIHttpChannel);
			ch.requestMethod = "HEAD";
			if(this.pu.getPref("network.http.sendRefererHeader", 2) > 1)
				ch.setRequestHeader("Referer", this.referer, null);
			ch.loadFlags |= ch.LOAD_BACKGROUND | ch.INHIBIT_CACHING;
			ch.visitRequestHeaders(this);
			ch.asyncOpen(this, null);
			return true;
		}
		catch(e) {
			Components.utils.reportError(e);
		}
		return false;
	},

	//==
	_uri: null,
	get uri() {
		if(this.isOwnWindow)
			return document.getElementById("extLinkProps-uri").value;
		if(this.isPropsDialog)
			return document.getElementById("link-url-text").value;

		// Following code is part of FlashGot extension ( http://flashgot.net/ )
		// content\flashgot\flashgotDMOverlay.js
		return this._uri = dialog.mLauncher.source.spec;
	},
	get referer() {
		if(this.isPropsDialog)
			return window.arguments[0].ownerDocument.defaultView.location.href;
		if(this.isOwnWindow)
			return this.wnd.referer;

		// Following code is part of FlashGot extension ( http://flashgot.net/ )
		// content\flashgot\flashgotDMOverlay.js
		var openerDoc;
		try {
			openerDoc = dialog.mContext.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
				.getInterface(Components.interfaces.nsIDOMWindow)
				.document;
		} catch(ex) {
			openerDoc = top.opener && top.opener.content && top.opener.content.document || null;
		}
		var referer;
		try {
			referer = dialog.mContext.QueryInterface(Components.interfaces.nsIWebNavigation)
				.currentURI.spec;
		} catch(ex) {
			 referer = openerDoc && openerDoc.URL || this._uri;
		}
		return referer;
	},
	//==

	visitHeader: function(header, value) {
		this.fullHeader.value += header + ": " + value +"\n";
		switch(header) {
			case "Content-Length": this.formatSize(value); break;
			case "Last-Modified":  this.formatDate(value); break;
			case "Content-Type":   this.formatType(value); break;
		}
	},
	formatSize: function(rawSize) {
		var textSize = this.getSizeStr(rawSize);
		var target = document.getElementById("extLinkProps-size");
		if(this._hasSize) {
			if(textSize != target.value) {
				this._lastSizeTip = rawSize;
				target.setAttribute("tooltiptext", textSize);
			}
		}
		else {
			this._hasSize = true;
			this._lastSize = rawSize;
			this.setMissingStyle(target, false);
			target.value = textSize;
			if(!this._hasSize)
				target.removeAttribute("tooltiptext");
		}
	},
	convertSize: function() {
		var target = document.getElementById("extLinkProps-size");
		if(this._lastSize !== null)
			target.value = this.getSizeStr(this._lastSize);
		if(this._lastSizeTip !== null)
			target.setAttribute("tooltiptext", this.getSizeStr(this._lastSizeTip));
	},
	getSizeStr: function(rawSize) {
		var intSize = parseInt(rawSize);
		if(intSize < 0)
			return;
		var size = this.formatNumStr(String(rawSize));
		var textSize = "";
		if(intSize > 1024*1024*1024) {
			textSize = this.formatNum(intSize/1024/1024/1024);
			textSize = this.stringbundle.formatStringFromName("gigabytes", [textSize, size], 2);
		}
		else if(intSize > 1024*1024) {
			textSize = this.formatNum(intSize/1024/1024);
			textSize = this.stringbundle.formatStringFromName("megabytes", [textSize, size], 2);
		}
		else if(intSize > 512) {
			textSize = this.formatNum(intSize/1024);
			textSize = this.stringbundle.formatStringFromName("kilobytes", [textSize, size], 2);
		}
		else {
			textSize = this.stringbundle.formatStringFromName("bytes", [size], 1);
		}
		return textSize;
	},
	get localeDelimiter() { // Detect locale delimiter (e.g. 0.1 -> 0,1)
		delete this.localeDelimiter;
		return this.localeDelimiter = /\D/.test(.1.toLocaleString()) ? RegExp.lastMatch : ".";
	},
	formatNum: function(n) {
		return this.formatNumStr(
			n.toFixed(this.pu.pref("sizePrecision") || 0).replace(/\./, this.localeDelimiter)
		);
	},
	formatNumStr: function(s) {
		return s.replace(/(\d)(?=(?:\d{3})+(?:\D|$))/g, "$1 "); // 12345678 -> 12 345 678
	},
	formatDate: function(str) {
		var target = document.getElementById("extLinkProps-lastModified");
		this.setMissingStyle(target, str);
		target.value = new Date(str).toLocaleString();
	},
	formatType: function(str) {
		var target = document.getElementById("extLinkProps-contentType");
		if(this._hasType) {
			if(str != target.value)
				target.setAttribute("tooltiptext", str);
		}
		else {
			this._hasType = true;
			this.setMissingStyle(target, str);
			target.value = str;
			target.removeAttribute("tooltiptext");
		}
	},
	formatStatus: function(status, statusText) {
		var tb = document.getElementById("extLinkProps-status");
		tb.value = status + (statusText ? " " + statusText : "");
		this.setMissingStyle(tb, status >= 400 && status < 600);
	},

	fillInBlank: function() {
		var target = document.getElementById("extLinkProps-size");
		var missing = this.stringbundle.GetStringFromName("missing");
		if(!target.value) {
		/*
			try {
				this.channel.QueryInterface(Components.interfaces.nsICachingChannel);
				if(this.channel.isFromCache())
					alert(this.channel);
			} catch(e) { alert(e) }
		*/
			this.setMissingStatus(target, missing);
		}

		target = document.getElementById("extLinkProps-contentType");
		if(!target.value)
			this.setMissingStatus(target, missing);

		target = document.getElementById("extLinkProps-lastModified");
		if(!target.value)
			this.setMissingStatus(target, missing);

		target = document.getElementById("extLinkProps-status");
		if(!target.value)
			this.setMissingStatus(target, missing);
	},
	setMissingStatus: function(target, text) {
		target.value = text;
		this.setMissingStyle(target, true);
	},
	setMissingStyle: function(target, isMissing) {
		target.setAttribute("elp_missing", isMissing);
	},

	onDataAvailable: function(request, ctxt, input, offset, count) {
		this.realCount += count;
		var bInput = Components.classes["@mozilla.org/binaryinputstream;1"]
			.createInstance(Components.interfaces.nsIBinaryInputStream);
		bInput.setInputStream(input);
		this.fullHeader.value += bInput.readBytes(count);
	},
	onStartRequest: function(request, ctxt) {
		try {
			request.QueryInterface(Components.interfaces.nsIHttpChannel);
			this.fullHeader.value += "\n" + "Status: " + request.responseStatus + " " + request.responseStatusText + "\n";
			this.formatStatus(request.responseStatus, request.responseStatusText);
			request.visitResponseHeaders(this);
		}
		catch(e) { // FTP?
			var ch = this.channel;
			if(!ch)
				return; // Window is closed
			if("contentType" in ch)
				try { this.formatType(ch.contentType); }
				catch(e) {}
			if("contentLength" in ch)
				try { this.formatSize(ch.contentLength); }
				catch(e) {}
			if("responseStatus" in ch)
				try { this.formatStatus(ch.responseStatus, ch.responseStatusText); }
				catch(e) {}
			//Components.utils.reportError("[Extended Link Properties]: Can't get request headers");
			//throw e;
		}
		finally {
			request.cancel(0);
			if(this.channel) {
				this.fillInBlank();
				this.channel = null;
			}
		}
	},
	onStopRequest: function(request, ctxt, status) {
		if(this.realCount > 0)
			this.formatSize(this.realCount.toString());
		if(document)
			this.fullHeader.value = this.fullHeader.value.replace(/\n+$/, "");
	}
};

window.addEventListener("load", extLinkPropsSvc, false);