var extLinkPropsOpts = {
	get pu() { return extLinkPropsPrefUtils; },
	init: function() {
		this.disable();
		var de = document.documentElement;
		var applyBtn = this.applyBtn = de.getButton("extra1");
		if(this.pu.getPref("browser.preferences.instantApply"))
			this.applyBtn.hidden = true;
		else {
			this.applyBtn.disabled = true;
			this.applyBtn.setAttribute("icon", "apply");
		}

		// Insert Apply button between Ok and Cancel
		var okBtn = de.getButton("accept");
		var cancelBtn = de.getButton("cancel");
		var btnBox = okBtn.parentNode;
		for(var node = btnBox.firstChild; node; node = node.nextSibling) {
			if(node == okBtn || node == cancelBtn) {
				node = node.nextSibling;
				if(node != applyBtn)
					btnBox.insertBefore(applyBtn, node);
				break;
			}
		}

		// Show settings for Properties dialog, if available
		var propsBox = document.getElementById("propertiesBox");
		var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULAppInfo);
		if(
			appInfo.name == "Firefox"
			&& parseFloat(appInfo.version) >= 3.6
		) {
			var guid = "properties@darktrojan.net";
			if("@mozilla.org/extensions/manager;1" in Components.classes) {
				Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
					.getService(Components.interfaces.mozIJSSubScriptLoader)
					.loadSubScript("chrome://extlinkprops/content/extsHelper.js");
				extLinkPropsExtensionsHelper.isAvailable(guid) && propsBox.removeAttribute("hidden");
			}
			else if("Application" in window && "getExtensions" in Application) { // Firefox 3.7a
				Application.getExtensions(function(exts) {
					if(exts.has(guid) && exts.get(guid).enabled) {
						propsBox.removeAttribute("hidden");
						window.sizeToContent();
					}
				});
			}
			return;
		}
		propsBox.removeAttribute("hidden");
	},
	e: function(p) {
		return document.getElementsByAttribute("preference", p)[0];
	},
	disable: function() {
		this.e("icon.contextMenu").disabled = !this.e("context.onLinks").checked && !this.e("context.onSelection").checked;
		this.e("icon.toolsMenu")  .disabled = !this.e("showInToolsMenu").checked;
	},
	savePrefpanes: function() {
		Array.forEach(
			document.getElementsByTagName("prefpane"),
			function(pp) {
				pp.writePreferences(true /* aFlushToDisk */);
			}
		);
		this.applyBtn.disabled = true;
	},
	allowApply: function(e) {
		if(e.target.hasAttribute("preference"))
			this.applyBtn.disabled = false;
	}
};