var extLinkProps = {
	//validURI: /^\w+:\/\S+$/,
	validURI: /^(?:http|ftp)s?:\/\/\S+$/,

	linkURL: "",
	referer: null,

	get pu() { return extLinkPropsPrefUtils; },
	init: function() {
		window.removeEventListener("load", this, false);
		window.addEventListener("unload", this, false);
		this.cm.addEventListener("popupshowing", this, false);
		this.showHideTools();
		this.showHideIcons();
		this.registerHotkeys();
	},
	destroy: function() {
		window.removeEventListener("unload", this, false);
		this.cm.removeEventListener("popupshowing", this, false);
	},
	/*
	get noPropsItem() {
		delete this.noPropsItem;
		return this.noPropsItem = !document.getElementById("context-metadata");
	},
	*/
	get cm() {
		return document.getElementById("contentAreaContextMenu");
	},
	get mi() {
		return document.getElementById("extLinkProps-contextMenuitem");
	},
	isValidURI: function(s) {
		return s && this.validURI.test(s);
	},
	prefsChanged: function(pName) {
		if(pName == "showInToolsMenu")
			this.showHideTools();
		else if(pName.indexOf("icon.") == 0)
			this.showHideIcons();
	},
	showHideTools: function() {
		document.getElementById("extLinkProps-toolsMenuitem").setAttribute("hidden", !this.pu.pref("showInToolsMenu"));
	},
	showHideIcons: function() {
		const attr = "elp_iconized";
		document.getElementById("extLinkProps-contextMenuitem").setAttribute(attr, this.pu.pref("icon.contextMenu"));
		document.getElementById("extLinkProps-toolsMenuitem").setAttribute(attr, this.pu.pref("icon.toolsMenu"));
	},
	setMenu: function() {
		var hide = true;
		if(
			gContextMenu
			&& gContextMenu.onSaveableLink// && this.noPropsItem
			&& this.pu.pref("context.onLinks")
			&& this.isValidURI(gContextMenu.linkURL)
		) {
			this.linkURL = gContextMenu.linkURL;
			this.referer = gContextMenu.link.ownerDocument.location.href;
			hide = false;
		}
		else if(this.pu.pref("context.onSelection")) {
			var sel = document.commandDispatcher.focusedWindow.getSelection().toString().replace(/^\s+|\s+$/g, "");
			if(this.isValidURI(sel)) {
				this.linkURL = sel;
				this.referer = null; //gContextMenu.target.ownerDocument.location.href;
				hide = false;
			}
		}
		var mi = this.mi;
		mi.hidden = hide;
		!hide && mi.setAttribute("tooltiptext", this.linkURL);
	},
	openWindow: function(uri, referer) {
		if(!uri) {
			uri = readFromClipboard();
			if(!this.isValidURI(uri))
				uri = "";
		}
		window.openDialog(
			"chrome://extlinkprops/content/ownWindow.xul",
			"_blank",
			"chrome,resizable,centerscreen,dialog=0",
			uri, referer, arguments.length > 0
		);
	},
	handleEvent: function(e) {
		switch(e.type) {
			case "load":         this.init();    break;
			case "unload":       this.destroy(); break;
			case "popupshowing": this.setMenu();
		}
	},

	// Hotkeys:
	registerHotkeys: function() {
		this.pu.prefSvc.getBranch(this.pu.prefNS + "key.")
			.getChildList("", {})
			.forEach(this.registerHotkey, this);
	},
	registerHotkey: function(kId) {
		var kElt = document.getElementById("extLinkProps-key-" + kId);
		if(!kElt)
			return; //~ todo: show warning in console
		var keyStr = this.pu.pref("key." + kId);
		if(!keyStr) { // Key is disabled
			// Strange things may happens without this for <key command="..." />
			kElt.parentNode.removeChild(kElt);
			return;
		}
		var tokens = keyStr.split(" ");
		var key = tokens.pop() || " ";
		var modifiers = tokens.join(",");
		kElt.removeAttribute("disabled");
		kElt.setAttribute(key.indexOf("VK_") == 0 ? "keycode" : "key", key);
		kElt.setAttribute("modifiers", modifiers);
	}
};
window.addEventListener("load", extLinkProps, false);