var extLinkPropsWnd = {
	getDelay: 300,

	uri: "",
	referer: null,
	autostart: true,

	init: function() {
		if("arguments" in window) {
			var wa = window.arguments || [];
			document.getElementById("extLinkProps-uri").value = this.uri = wa[0] || "";
			this.referer = wa[1] || null;
			this.autostart = !!wa[2];
			this.setTitle();
		}
	},
	setTitle: function() {
		var ttl = document.title.replace(/\s+\[.*\]$/, "");
		if(this.uri) {
			var fName = /[^\/\\]+$/.test(this.uri) ? RegExp.lastMatch : this.uri;
			ttl += " [" + fName + "]";
		}
		document.title = ttl;
	},
	getHeaders: function() {
		var butt = document.getElementById("extLinkProps-getHeaders");
		var uri = document.getElementById("extLinkProps-uri").value;
		if(butt.disabled || !uri)
			return;
		butt.disabled = true;
		this.uri = uri;
		this.setTitle();
		extLinkPropsSvc.getHeaders(true);
		this.fixWindowHeight();
		setTimeout(function(butt) {
			butt.disabled = false;
		}, this.getDelay, butt);
	},
	fixWindowHeight: function() {
		//var w = window.outerWidth;
		//window.resizeBy(0, 50 - window.outerHeight);
		//window.sizeToContent();
		//window.resizeBy(w - window.outerWidth, 0);
		var de = document.documentElement;
		var contentHeight = 0;
		var ac = document.getAnonymousNodes(de), a;
		for(var i = 0, l = ac.length; i < l; i++) {
			a = ac[i];
			if(a.parentNode === de)
				contentHeight += this.getHeight(a);
		}
		var containerHeight = this.getHeight(de, true);
		if(contentHeight > containerHeight)
			window.resizeBy(0, contentHeight - containerHeight);
	},
	getIntProperty: function(elt, pName) {
		return parseInt(elt.ownerDocument.defaultView.getComputedStyle(elt, null)[pName]) || 0;
	},
	getHeight: function(elt, external) {
		var h = elt.boxObject.height;
		var padding = this.getIntProperty(elt, "paddingTop") + this.getIntProperty(elt, "paddingBottom");
		if(external)
			return h - padding;
		h += padding
			+ this.getIntProperty(elt, "borderTopWidth") + this.getIntProperty(elt, "borderBottomWidth")
			+ this.getIntProperty(elt, "marginTop") + this.getIntProperty(elt, "marginBottom");
		return h;
	}
};
extLinkPropsWnd.init();
window.addEventListener("resize", function _rs(e) {
	window.removeEventListener(e.type, _rs, false);
	extLinkPropsWnd.fixWindowHeight();
}, false);